#include "LinearAlgebra/Spherical.h"
#include "LinearAlgebra/SwingTwist.h"

namespace Passer {
namespace Control {

class LowLevelMessages {
public:
  static void SendAngle8(unsigned char *buffer, unsigned char *ix,
                         const float angle);
  static Angle8 ReceiveAngle8(const unsigned char *buffer,
                              unsigned char *startIndex);

  static void SendFloat16(unsigned char *buffer, unsigned char *ix,
                          float value);
  static float ReceiveFloat16(const unsigned char *buffer,
                              unsigned char *startIndex);

  static void SendSpherical16(unsigned char *buffer, unsigned char *ix,
                              Spherical16 s);
  static Spherical16 ReceiveSpherical16(const unsigned char *buffer,
                                        unsigned char *startIndex);

  static void SendQuat32(unsigned char *buffer, unsigned char *ix,
                         SwingTwist16 q);
  static SwingTwist16 ReceiveQuat32(const unsigned char *buffer,
                                    unsigned char *ix);
};

} // namespace Control
} // namespace Passer
using namespace Passer::Control;